blood_shadow = LoadSpriteset("blood1shadow.rss")

function SpawnBlood(x,y,z,vx,vy)
{
	for (var j=0;j<maxEntities;j++)
	{
		if (entities[j].active == false)
		{
			entities[j].active = true
			entities[j].frame_update = true
			entities[j].x = x;
			entities[j].y = y;
			entities[j].z = Math.max(z, MIN_HEIGHT+0.01);
			entities[j].vz = JUMP_SPEED*1.2
			
			angle = Math.random()*2*3.14159
			speed = (1/2)*PUNCH_SPEED*(0.75+0.25*Math.random())
			entities[j].vx = vx+speed*Math.sin(angle)
			entities[j].vy = vy+speed*Math.cos(angle)

      entities[j].spriteset = "blood1.rss"

			SetPersonSpriteset(entities[j].name, LoadSpriteset(entities[j].spriteset));
			SetPersonSpriteset(entities[j].name+"shadow", blood_shadow);
			SetPersonLayer(entities[j].name, entities[j].layer)
			SetPersonScaleFactor(entities[j].name, 4, 4)
			SetPersonScaleFactor(entities[j].name+"shadow", 4, 4)
			break
		}
	}
}

function SpawnGibs(i, gibs, loop)
{
  x = entities[i].x;
  y = entities[i].y;
  z = entities[i].z;
  vx = entities[i].vx/2;
  vy = entities[i].vy/2;
  
  ss = entities[i].spriteset
	entities[i].active = false;
	if (loop==undefined)
	{
		loop= 1
	}

	var j=0;
	for (var p=0;p<loop;p++)
	{
		for (var l=0; l< gibs; l++)
		{
			for (;j<maxEntities;j++)
			{
				if (entities[j].active == false)
				{
					entities[j].active = true
					entities[j].frame_update = false;
					entities[j].x = x;
					entities[j].y = y;
					entities[j].z = Math.max(z, MIN_HEIGHT+0.01);
					entities[j].vz = JUMP_SPEED*1.2*(Math.sqrt(entities[i].weight))*(0.5+Math.random())
					entities[j].layer = 3
					entities[j].blood_type = "blood"
					if (ss == "rabbit1.rss")
					{
						entities[j].spriteset = "rabbit1gib.rss";
						entities[j].blood_type = "blood"
					}
					else if (ss == "boss1.rss")
					{
						entities[j].spriteset = "boss1gib.rss"
						entities[j].blood_type = "stone"
					}

					entities[j].dir = "north"
					if (l > 2)
					{
						entities[j].frame = 2+Math.floor(Math.random()*2)
					}
					else
					{
						entities[j].frame = l
					}
					 
				
					angle = Math.random()*2*3.14159
					speed = (1/4)*PUNCH_SPEED*(0.75+0.25*Math.random())*(entities[i].weight)*Math.random()
					entities[j].vx = vx+speed*Math.sin(angle)
					entities[j].vy = vy+speed*Math.cos(angle)
					entities[j].type = "gib"
					
					entities[j].a = Math.random()*2*3.14159
					entities[j].va = Math.random()*MAX_ANGLE_SPEED

					SetPersonSpriteset(entities[j].name, LoadSpriteset(entities[j].spriteset));
					SetPersonSpriteset(entities[j].name+"shadow", LoadSpriteset("blood1shadow.rss"));
					SetPersonLayer(entities[j].name, entities[j].layer)
					SetPersonScaleFactor(entities[j].name, 4, 4)
					SetPersonScaleFactor(entities[j].name+"shadow", 4, 4)
					break
				}
			}
		}
	}
}



g_blood_surface = CreateSurface(1600,920, CreateColor(0,0,0,0))
g_blood_surface.setBlendMode(BLEND)

g_blood_image = g_blood_surface.createImage()
g_blood_recalc = false

function ResetBlood()
{
	g_blood_surface = CreateSurface(1600,920, CreateColor(0,0,0,0))
	g_blood_surface.setBlendMode(BLEND)

	g_blood_image = g_blood_surface.createImage()
	g_blood_recalc = false
}

g_bloody = LoadSurface("bloody1.png")

g_stoney = LoadSurface("stoney1.png")



function	DrawBloodOverlay()
{
  x = MapToScreenX(1, 0)
  y = MapToScreenY(1, 0)

	g_blood_image.zoomBlitMask(x,y,4, CreateColor(255,255,255,128));
	
}

function KillBlood(j)
{
	g_blood_recalc = true;
	if (entities[j].blood_type == "stone")
	{
		g_blood_surface.blitSurface(g_stoney, entities[j].x, entities[j].y-entities[j].z)
	}
	else //if (entities[j].blood_type == "blood")
	{
		g_blood_surface.blitSurface(g_bloody, entities[j].x, entities[j].y-entities[j].z)
	}

	if (entities[j].type == "blood")
	{
		entities[j].vx = 0;
		entities[j].vy = 0;
		entities[j].vz = 0;
		entities[j].active = false;
		
		entities[j].x = 0
		entities[j].y = 0
		entities[j].z = 0;
	}
}

function CheckBloodOverlayRecalc()
{
	if (g_blood_recalc == true && g_frames%FRAMEUPDATES == 0)
	{
		g_blood_image = g_blood_surface.createImage()
		g_blood_recalc = false
	}
}

