maxEntities = 100

entities = Array()
function ClearEntities()
{
	if (entities.length > 0)
	{
		old_hp = entities[0].hp
	}
	else
	{
		old_hp = undefined
	}
	for (var i=0;i<maxEntities;i++)
	{
		entities[i] = new Object();
		entities[i].x = 0;
		entities[i].y = 0;
		entities[i].z = 0;
		entities[i].a = 0
		entities[i].vx = 0.1;
		entities[i].vy = -0.1;
		entities[i].vz = -0.75;
		entities[i].va = 0;
		entities[i].w = 16;
		entities[i].h = 32;
		
		entities[i].sox = 0;
		entities[i].soy = 0;
		entities[i].layer = 2
		entities[i].dir = "north";
		entities[i].frame = 0;
		entities[i].spriteset = "blood1.rss"
		entities[i].shadow_spriteset = "blood1shadow.rss"
		entities[i].name = "ent"+i
		entities[i].type = "blood"
		entities[i].active = false
		entities[i].alerted = false
		entities[i].counter = 0
		entities[i].action = "";
		entities[i].hp = 100;
		entities[i].maxhp = 100;
		entities[i].type_num = 0;
		entities[i].frame_update = true
		entities[i].weight = 1;
		entities[i].blood = true
	}

	entities[0].spriteset = "main1.rss"
	entities[0].shadow_spriteset = "main1shadow.rss"
	entities[0].type = "player"
	entities[0].active = true
	entities[0].x = 90;
	entities[0].y = 80+10;
	if (old_hp != undefined)
	{
		entities[0].hp = old_hp
	}
	else
	{
		entities[0].hp = entities[0].maxhp
	}
	entities[0].dir = "west"
}
ClearEntities()


atk_diff = 0.25

enemy_types = Array()

enemy_types[0] = new Object()
enemy_types[0].attack_range = 16
enemy_types[0].attack_val = 5*atk_diff
enemy_types[0].alert_dist = 48;

enemy_types[1] = new Object()
enemy_types[1].attack_range = 16
enemy_types[1].attack_val = 5*atk_diff
enemy_types[1].alert_dist = 48;



enemy_types[2] = new Object()
enemy_types[2].attack_range = 32
enemy_types[2].attack_val = 5*atk_diff
enemy_types[2].alert_dist = 50;


function AddEnemy(x,y,type)
{
	for (var i=1;i<maxEntities;i++)
	{
		if (entities[i].active == false)
		{
			if (type == 0 || type == 3)
			{
				entities[i].spriteset = "rabbit1.rss"
				entities[i].shadow_spriteset = "shadow.rss"
				entities[i].type = "enemy"
				entities[i].active = true
				entities[i].x = x*TILE;
				entities[i].y = y*TILE-TILE/2-1;
				entities[i].type_num = 0;
				entities[i].layer = 4;
				entities[i].sox = 0;
				entities[i].soy = 0;

				entities[i].hp = 10*Math.min(g_level+1,10);
				entities[i].maxhp = 10*Math.min(g_level+1,10);
				
				if (type == 3)
				{
					entities[i].hp = 5;
					entities[i].maxhp = 5;
					entities[i].ender = true
				}
			}
			if (type == 2)
			{
				entities[i].spriteset = "boss1.rss"
				entities[i].shadow_spriteset = "boss1shadow.rss"
				entities[i].type = "enemy"
				entities[i].active = true
				entities[i].x = x*TILE+TILE/2;
				entities[i].y = y*TILE-TILE/2-1;
		
				entities[i].frame_update = false;
				entities[i].type_num = 2;
				entities[i].layer = 4;
				entities[i].sox = 13*4;
				entities[i].soy = 32*4;
				entities[i].weight = 3
				entities[i].blood = false

				entities[i].hp = 200;
				entities[i].maxhp = 200;
			}
			
			break
		}
	}

}



FRICTION = 0.1
MIN_FRICTION = 0.2
GRAVITY = 0.08
MAX_GRAVITY = -3
MIN_HEIGHT = 0.4
BOUNCE = 0.7

XY_SPEED = 1.2
JUMP_SPEED = 1.75

HOP_SPEED = 1.5
XY_HOP_SPEED = 0.4

BOSS_JUMP = 2
BOSS_XY = 1.3


PUNCH_SPEED = 1.2
PUNCH_SPEED_Z = 0.8

MAX_ANGLE_SPEED=0.5

TILE = 16

BLOOD_SPAWN_RATE = 4*2

shadow_w = 10
shadow_h = 46

player_attack_val = 20

walkDirections = {"north":1, "west":1, "south":1, "east":1}
attackDirections = {"northpunch":1, "westpunch":1, "southpunch":1, "eastpunch":1}


FRAMEUPDATES = 6

function PrepEntitiesFirstTime()
{
	entities[0].hp = entities[0].maxhp
	for (i=0;i<maxEntities;i++)
	{
	  entities[i].name = "ent"+i
		CreatePerson(entities[i].name, entities[i].spriteset, false);	
		CreatePerson(entities[i].name+"shadow", "shadow.rss", false);	
	}
}

function PrepEntities()
{
	g_screen_off = false

	for (i=0;i<maxEntities;i++)
	{
		if (i==0)
		{
			entities[0].spriteset = "main1.rss"
			entities[0].shadow_spriteset = "shadow.rss"
			entities[0].x = g_start[0]*TILE;
			entities[0].y = g_start[1]*TILE+TILE/2-16-2;
			entities[0].layer = 4;
			entities[0].z = 0
			entities[0].vz = 0
			entities[0].frame = 0;
			for (var h=0;h< g_map_changes.length; h++)
			{
				if (g_level == g_map_changes[h])
				{
					entities[0].hp = entities[0].maxhp;
				}
			}

		}

		SetPersonSpriteset(entities[i].name, LoadSpriteset(entities[i].spriteset));
		SetPersonSpriteset(entities[i].name+"shadow", LoadSpriteset(entities[i].shadow_spriteset));
		SetPersonLayer(entities[i].name, entities[i].layer)
		SetPersonScaleFactor(entities[i].name, 4, 4)
		SetPersonScaleFactor(entities[i].name+"shadow", 4, 4)
		base = GetPersonBase(entities[i].name)
		entities[i].w = Math.abs(base.x2-base.x1)
		entities[i].h = Math.abs(base.y2-base.y1)
	}
}

function UpdateEntities()
{
	for (var i=0;i<maxEntities;i++)
	{
		//First, update the physics:
		
		UpdatePhysics(i)
		UpdateAI(i)
		UpdateFrames(i)
		

	}
}

function UpdatePhysics(i)
{
	if (entities[i].type == "blood")
	{
		entityFriction = 1
		entityBounce = 0
	}
	else
	{
		if (entities[i].type_num == 2)
		{
			entityFriction = FRICTION*2;
			entityBounce = BOUNCE/2
		
		}
		else
		{
			
			entityFriction = FRICTION;
			entityBounce = BOUNCE
		}
	}
		
	if (IsEntityOnGround(i) == true)
	{
		//reduce vx/vy by friction
		entities[i].vx += -1*sign(entities[i].vx)*entityFriction
		entities[i].vy += -1*sign(entities[i].vy)*entityFriction
		if (Math.abs(entities[i].vx) < MIN_FRICTION)
		{
			entities[i].vx = 0
		}
		if (Math.abs(entities[i].vy) < MIN_FRICTION)
		{
			entities[i].vy = 0
		}
		
		if (entities[i].va != 0)
		{
			entities[i].va+= -1*sign(entities[i].va)*entityFriction
			if (Math.abs(entities[i].va) < MIN_FRICTION)
			{
				entities[i].va = 0
			}
		}

		
		if (entities[i].type == "blood" && entities[i].active == true)
		{
			KillBlood(i)
		}
	}
	
	if (IsEntityOnGround(i) == false || Math.abs(entities[i].vz) > 1)
	{
		entities[i].vz -= GRAVITY;
		if (entities[i].vz < MAX_GRAVITY)
		{
			entities[i].vz = MAX_GRAVITY;
		}
	}
	
	entities[i].x+=entities[i].vx;
	entities[i].y+=entities[i].vy;
	entities[i].z+=entities[i].vz;
	entities[i].a+=entities[i].va;
	//Debug(entities[i].w+ " "+entities[i].h)
	if (entities[i].z < 0)
	{
		//Apply bounce
		
		if (entities[i].type_num == 2 && entities[i].hp > 0 && entities[i].vz < -1.4)
		{
			DoAttack(i)
			PlaySound(6);
		}
		
		
		if (entities[i].no_bounce == true)
		{
			entities[i].vz = 0
			entities[i].z = 0
			
		}
		else
		{
			entities[i].vz *= -1*entityBounce
			entities[i].z = 0
			if (Math.abs(entities[i].vz) < MIN_HEIGHT)
			{
				entities[i].vz = 0
			}
			
			if (entities[i].type == "gib")
			{
				KillBlood(i)
			}
		}
	}
		
	if (IsEntityObstructed(i))
	{
		if (entities[i].type == "blood" && entities[i].active == true)
		{
			KillBlood(i)
		}			

	  oldX = entities[i].x-entities[i].vx;
	  oldY = entities[i].y-entities[i].vy;

    for (t=10;t>= 0;t--)
    {
			entities[i].x = oldX+(t/10.0)*entities[i].vx
			entities[i].y = oldY+(t/10.0)*entities[i].vy
			if (!IsEntityObstructed(i))
			{
			  //check horizontal/vertical bounce:
			  xDiff = (1/10.0)*entities[i].vx
			  yDiff = (1/10.0)*entities[i].vy
			  
			  eitherCheck = false
			  if (IsEntityObstructedAt(i, entities[i].x+xDiff, entities[i].y))
			  {
					entities[i].vx*=-1*entityBounce;
					if (!IsEntityObstructedAt(i, entities[i].x+xDiff, entities[i].y+entities[i].vy))
					{
						entities[i].y += entities[i].vy
					}
					eitherCheck = true;	
				}
				
			  if (IsEntityObstructedAt(i, entities[i].x, entities[i].y+yDiff))
			  {
					entities[i].vy*=-1*entityBounce;
					if (!IsEntityObstructedAt(i, entities[i].x+entities[i].vx, entities[i].y+yDiff))
					{
						entities[i].x += entities[i].vx
					}
					eitherCheck = true;
			  }
			  
			  if (eitherCheck == false)
			  {
					entities[i].vx*=-1*entityBounce;
					entities[i].vy*=-1*entityBounce;
			  }
				  
			  break
			}
    }
	}
		
	//update frames:
	if (entities[i].frame_update == true)
	{
		if (IsEntityOnGround(i) && walkDirections[entities[i].dir] == 1)
		{		
			if (g_frames%FRAMEUPDATES == 0)
			{
				if (Math.abs(entities[i].vx) + Math.abs(entities[i].vy) > 0.05)
				{
					entities[i].frame+=1
				}
				else
				{
					entities[i].frame = 0
				}			
			}
		}
		else if (attackDirections[entities[i].dir] == 1)
		{
			if (g_frames%FRAMEUPDATES == 0)
			{
				entities[i].frame+=1
				if (entities[i].frame == 4)
				{
					entities[i].frame = 0
					entities[i].dir = entities[i].dir.split("punch")[0]
					entities[i].attack_active = false
					entities[i].vz = 0
				}
			}
			if (entities[i].attack_active == true)
			{
				DoAttack(i)
			}			
		}
		else if (IsEntityOnGround(i) == false)
		{
			if (entities[i].vz > 0)
			{
				entities[i].frame = 3
			}
			else
			{
				entities[i].frame = 5
			}
		}
	}
}

function DoAttack(k)
{
	if (k==0)
	{
		for (j=0;j<maxEntities;j++)
		{
			if (k!=j && Math.abs(entities[k].x+sign(entities[k].vx)*4-entities[j].x) < 8 &&
									Math.abs(entities[k].y+sign(entities[k].vy)*4-entities[j].y) < 8 &&
									Math.abs(entities[k].z-entities[j].z) < 8 &&
									entities[j].type == "enemy" &&
									entities[j].hp > 0)
			{
				//entity j hit!
				entities[j].vx = sign(entities[k].vx)*PUNCH_SPEED*1.35/entities[j].weight;
				entities[j].vy = sign(entities[k].vy)*PUNCH_SPEED*1.35/entities[j].weight;
				entities[j].vz = JUMP_SPEED*0.75/entities[j].weight
				entities[j].no_bounce = false
				DoDamage(j, player_attack_val)
				PlaySound(5)
					
				entities[k].attack_active = false
				
				if (entities[j].blood == true)
				{
					for (k=0;k<BLOOD_SPAWN_RATE;k++)
					{
						SpawnBlood(entities[j].x,entities[j].y,entities[j].z, entities[k].vx, entities[k].vy)
					}
				}
			}
		}
	}
	else
	{
		vcx = sign(entities[k].vx)*16
		vcy = sign(entities[k].vy)*16
		w = 12
		h = 12
		z = 8
		if (entities[k].type_num==2)
		{
			vcx = 0
			vcy = 0
			w = 20
			h = 20
			z = 3
		}

		j = 0;
		if (k!=j && Math.abs(entities[k].x+vcx-entities[j].x) < w &&
								Math.abs(entities[k].y+vcy-entities[j].y) < h &&
								Math.abs(entities[k].z-entities[j].z) < z &&
								entities[j].hp > 0)
		{
			//entity j hit!
			entities[j].vx = sign(entities[k].vx)*PUNCH_SPEED*1.35/entities[j].weight
			entities[j].vy = sign(entities[k].vy)*PUNCH_SPEED*1.35/entities[j].weight
			entities[j].vz = JUMP_SPEED*0.75/entities[j].weight
			entities[j].no_bounce = false
			DoDamage(j, enemy_types[entities[j].type_num].attack_val)
			PlaySound(5)
					
			entities[k].attack_active = false
					
			if (entities[j].blood == true)
			{
				for (k=0;k<BLOOD_SPAWN_RATE;k++)
				{
					SpawnBlood(entities[j].x,entities[j].y,entities[j].z, entities[k].vx, entities[k].vy)
				}
			}
		}	
	}
}

function DoDamage(j,damage)
{
	entities[j].alerted = true;
	entities[j].hp-=damage
	if (entities[j].hp <= 0)
	{
		entities[j].hp = 0;
		PlaySound(2)
		if (entities[j].ender == true)
		{
			EndGameStarter(j)
		}
		
		if (entities[j].type_num == 2)
		{
			SpawnGibs(j,15+Math.floor(Math.random()*6),4)
		}
		else
		{
			SpawnGibs(j,4+Math.floor(Math.random()*2))
		}
		
	}
}

function UpdateFrames(i)
{
	if (entities[i].type == "gib")
	{
		SetPersonOffsetY(entities[i].name, -1*Math.floor(entities[i].z)*4+4*18)
	}
	else
	{
		SetPersonOffsetY(entities[i].name,-1*Math.floor(entities[i].z)*4-entities[i].soy)
	}
	SetPersonOffsetX(entities[i].name,-entities[i].sox)
	SetPersonX(entities[i].name,entities[i].x*4)
	SetPersonY(entities[i].name,entities[i].y*4)
	SetPersonLayer(entities[i].name, entities[i].layer)

	SetPersonOffsetY(entities[i].name+"shadow", 5*4)
	SetPersonX(entities[i].name+"shadow",entities[i].x*4)
	SetPersonY(entities[i].name+"shadow",entities[i].y*4)
	SetPersonLayer(entities[i].name+"shadow", entities[i].layer-2)
		
	SetPersonDirection(entities[i].name, entities[i].dir)
	SetPersonFrame(entities[i].name, entities[i].frame)
	entities[i].frame = GetPersonFrame(entities[i].name)
	
	SetPersonAngle(entities[i].name, entities[i].a)
}

function IsEntityOnGround(i)
{
	if (entities[i].z < MIN_HEIGHT)
	{
		return true
	}
	return false
}


function IsEntityObstructed(i)
{
	return IsEntityObstructedAt(i, entities[i].x, entities[i].y)
}


function IsEntityObstructedAt(i,x,y)
{
	returnVal = false
	w = entities[i].w
	h = entities[i].h
	
	x1 = Math.floor((x+4)/TILE)
	x2 = Math.floor((x+4+w)/TILE)
	y1 = Math.floor((y+20)/TILE)
	y2 = Math.floor((y+h+20)/TILE)
	if (GetTile(x1,y1, 0)==7 || GetTile(x1,y2,0) == 7 || GetTile(x2,y1,0) == 7 || GetTile(x2,y2,0) == 7)
	{
		returnVal = true
	}
	return returnVal
}

